#include <cstdio>
#include <cassert>
#include <cstring>

#define BUFFSIZE 1024

int main(int argc, const char *argv[])
{
	assert(argc == 4);
	
	FILE *fin = fopen(argv[1], "r");
	FILE *fok = fopen(argv[2], "r");
	FILE *fout = fopen(argv[3], "r");

	bool ok = true;

	int N;
	fscanf(fin, "%d", &N);

	char c;
	fscanf(fok, "%c", &c);

	if (c == 'N') {
		char buf[BUFFSIZE];
		fscanf(fout, "%20s", buf);
		if (strcmp(buf, "NEEXISTUJE") != 0) {
			ok = false;
		}
	} else {
		int firsta, currentb;
		bool first = true;
		for (int i=0; i<N; i++) {
			int Si;
			fscanf(fin, "%d", &Si);

			int V;
			if (fscanf(fout, "%d", &V) != 1) {
				ok = false;
				break;
			}

			--V;
			if (V < 0 || V >= Si) {
				ok = false;
				break;
			}

			int a, b;
			for (int j=0; j<Si; j++) {
				int ta, tb;
				fscanf(fin, "%d%d", &ta, &tb);
				if (j == V) {
					a = ta; b = tb;
				}
			}

			if (first) {
				firsta = a;
				currentb = b;
				first = false;
			} else {
				if (currentb != a) {
					ok = false;
					break;
				} else {
					currentb = b;
				}
			}
		}
		if (currentb == firsta && ok) {
			ok = true;
		} else {
			ok = false;
		}
	}

	fclose(fin);
	fclose(fok);
	fclose(fout);

	return ok?0:1;
}
